:li

!!! ---Listing 1 ---

     #include <malloc.h>
     
     int
     dummy(char **a)         
     {
      /* Speicherleck erzeugen */
      *a = 0;
     }
     
     int
     main()
     {
      char *zone=malloc(20);
      char *ptr=NULL;
      int i;
      char c;
     
      c=zone[1];             /* Lesen von nicht-initialisertem Wert */
      c=zone[-2];            /* Lesen von nicht-alloziertem Bereich */
      zone[25]=' ';          /* Schreiben in nicht-allozierten Bereich */
      zone[4]=(char)i;       /* Lesen von nicht-initialisiertem Stack */
      dummy(&zone);          /* produce a leak */
     }

--- Ausgabe von checkergcc ---

>From Checker (pid:03023): (ruh) read uninitialized byte(s) in a block.
When Reading 1 byte(s) at address 0x1681d, inside the heap (sbrk).
1 bytes into a block (start: 0x1681c, length: 20, mdesc: 0x0).
The block was allocated from:
        pc=0x00005d7f in _malloc() at ./l-malloc/malloc.c:188
        pc=0x00005dde in malloc() at ./l-malloc/malloc.c:203
        pc=0x000010ea in main() at bsp1.c:12
        pc=0x00001079 in __entry() at chkrcrt0.S:1
Stack frames are:
        pc=0x00001120 in main() at bsp1.c:17
        pc=0x00001079 in __entry() at chkrcrt0.S:1
>From Checker (pid:03023): (bvh) block bounds violation in the heap.
When Reading 1 byte(s) at address 0x1681a, inside the heap (sbrk).
2 bytes before a block (start: 0x1681c, length: 20, mdesc: 0x0).
The block was allocated from:
        pc=0x00005d7f in _malloc() at ./l-malloc/malloc.c:188
        pc=0x00005dde in malloc() at ./l-malloc/malloc.c:203
        pc=0x000010ea in main() at bsp1.c:12
        pc=0x00001079 in __entry() at chkrcrt0.S:1
Stack frames are:
        pc=0x00001147 in main() at bsp1.c:18
        pc=0x00001079 in __entry() at chkrcrt0.S:1
>From Checker (pid:03023): (bvh) block bounds violation in the heap.
When Writing 1 byte(s) at address 0x16835, inside the heap (sbrk).
5 bytes after a block (start: 0x1681c, length: 20, mdesc: 0x0).

 .....

>From Checker (pid:03023): Garbage detector results:
There is 1 leak and 0 potentiel leak(s).
Leaks consume 20 bytes (0 KB) / 90 KB.
( 0.02% of memory is leaked.)
Found 1 block(s) of size 20.
Block at ptr=0x16aa0
        pc=0x00005d7f in _malloc() at ./l-malloc/malloc.c:188
        pc=0x000020de in my_getopt() at ./parse-args.c:489
        pc=0x000010ea in main() at bsp1.c:12
        pc=0x00001079 in __entry() at chkrcrt0.S:1

!!! --- Ende Listing 1 ---

!!! --- Listing 2 ---

#include <strings.h>
#include <stdlib.h>
#include <stdio.h>

main() {
  char *string;
  register int i;
  for (i = 0; i< 100000;  i++) {
    string = (char *)malloc(7);
    strcpy(string,"123456");
    free(string);
  }
}

!!! --- Ende Listing 2 ---

